##-----------------------------LICENSE NOTICE------------------------------------
##  This file is part of CPCtelera: An Amstrad CPC Game Engine 
##  Copyright (C) 2018 ronaldo / Fremos / Cheesetea / ByteRealms (@FranGallegoBR)
##
##  This program is free software: you can redistribute it and/or modify
##  it under the terms of the GNU Lesser General Public License as published by
##  the Free Software Foundation, either version 3 of the License, or
##  (at your option) any later version.
##
##  This program is distributed in the hope that it will be useful,
##  but WITHOUT ANY WARRANTY; without even the implied warranty of
##  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
##  GNU Lesser General Public License for more details.
##
##  You should have received a copy of the GNU Lesser General Public License
##  along with this program.  If not, see <http://www.gnu.org/licenses/>.
##------------------------------------------------------------------------------
############################################################################
##                        CPCTELERA ENGINE                                ##
##                 Automatic image conversion file                        ##
##------------------------------------------------------------------------##
## This file is intended for users to automate image conversion from JPG, ##
## PNG, GIF, etc. into C-arrays.                                          ##
############################################################################

##
## NEW MACROS
##

## 16 colours palette
PALETTE=11 15 24 18 20 5 6 26 25 3 13 19 9 0 8 2

#6 BRIGHT_RED 		#FF000000
#15 ORANGE 			#FF8000
#24 BRIGHT_YELLOW 	#FFFF00
#18 BRIGHT_GREEN	#00FF00
#20 BRIGHT_CYAN		#00FFFF
#5 MAUVE			#8000FF
#0 BLACK			#000000
#26 BRIGHT_WHITE	#FFFFFF
#25 PASTEL_YELLOW	#FFFF80
#3 RED				#800000
#13 WHITE			#808080 (Es mas gris que otra cosa)
#19 SEA_GREEN		#00FF80
#9	GREEN			#008000
#11 SKY_BLUE		#0080FF
#8 BRIGHT_MAGENTA	#FF00FF
#2 BRIGHT_BLUE		#0000FF

## Default values
#$(eval $(call IMG2SP, SET_MODE        , 0                  ))  { 0, 1, 2 }
#$(eval $(call IMG2SP, SET_MASK        , none               ))  { interlaced, none }
#$(eval $(call IMG2SP, SET_FOLDER      , src/               ))
#$(eval $(call IMG2SP, SET_EXTRAPAR    ,                    ))
#$(eval $(call IMG2SP, SET_IMG_FORMAT  , sprites            ))	{ sprites, zgtiles, screen }
#$(eval $(call IMG2SP, SET_OUTPUT      , c                  ))  { bin, c }
#$(eval $(call IMG2SP, SET_PALETTE_FW  , $(PALETTE)         ))
#$(eval $(call IMG2SP, CONVERT_PALETTE , $(PALETTE), g_palette ))
#$(eval $(call IMG2SP, CONVERT         , img.png , w, h, array, palette, tileset))

$(eval $(call IMG2SP, SET_MODE        , 0                  )) 
$(eval $(call IMG2SP, SET_OUTPUT      , c                  ))
$(eval $(call IMG2SP, SET_FOLDER      , src/assets/sprites/))
$(eval $(call IMG2SP, SET_PALETTE_FW  , $(PALETTE)         ))
$(eval $(call IMG2SP, CONVERT_PALETTE , $(PALETTE), g_palette ))

#Scores
$(eval $(call IMG2SP, SET_FOLDER      , src/assets/sprites/scores))

$(eval $(call IMG2SP, CONVERT         , assets/sprites/scores/nums_score.png, 10, 20, spr_num_score))

#Progress bar
$(eval $(call IMG2SP, SET_FOLDER      , src/assets/sprites/progress_bar))
$(eval $(call IMG2SP, CONVERT         , assets/sprites/progress_bar/progress_arrow.png, 8, 4, spr_progress_arrow))
$(eval $(call IMG2SP, CONVERT         , assets/sprites/progress_bar/progress_line.png, 44, 8, spr_progress_line))

#Player1
$(eval $(call IMG2SP, SET_FOLDER      , src/assets/sprites/player1))
	
$(eval $(call IMG2SP, CONVERT         , assets/sprites/player1/fungus_P1_base_left.png, 8, 16, spr_p1_base_left))
$(eval $(call IMG2SP, CONVERT         , assets/sprites/player1/fungus_P1_base_right.png, 8, 16, spr_p1_base_right))

$(eval $(call IMG2SP, CONVERT         , assets/sprites/player1/fungus_P1_idle_left.png, 8, 16, spr_p1_idle_left))
$(eval $(call IMG2SP, CONVERT         , assets/sprites/player1/fungus_P1_idle_right.png, 8, 16, spr_p1_idle_right))

$(eval $(call IMG2SP, CONVERT         , assets/sprites/player1/fungus_P1_run_left.png, 8, 16, spr_p1_run_left))
$(eval $(call IMG2SP, CONVERT         , assets/sprites/player1/fungus_P1_run_right.png, 8, 16, spr_p1_run_right))

$(eval $(call IMG2SP, CONVERT         , assets/sprites/player1/fungus_P1_jump_left.png, 8, 16, spr_p1_jump_left))
$(eval $(call IMG2SP, CONVERT         , assets/sprites/player1/fungus_P1_jump_right.png, 8, 16, spr_p1_jump_right))

$(eval $(call IMG2SP, CONVERT         , assets/sprites/player1/fungus_P1_die_left.png, 8, 16, spr_p1_die_left))
$(eval $(call IMG2SP, CONVERT         , assets/sprites/player1/fungus_P1_die_right.png, 8, 16, spr_p1_die_right))

$(eval $(call IMG2SP, CONVERT         , assets/sprites/player1/fungus_P1_shooting_right.png, 8, 16, spr_p1_shooting_right))
$(eval $(call IMG2SP, CONVERT         , assets/sprites/player1/fungus_P1_shooting_left.png, 8, 16, spr_p1_shooting_left))


#Player2
$(eval $(call IMG2SP, SET_FOLDER      , src/assets/sprites/player2))
	
$(eval $(call IMG2SP, CONVERT         , assets/sprites/player2/fungus_P2_base_left.png, 8, 16, spr_p2_base_left))
$(eval $(call IMG2SP, CONVERT         , assets/sprites/player2/fungus_P2_base_right.png, 8, 16, spr_p2_base_right))

$(eval $(call IMG2SP, CONVERT         , assets/sprites/player2/fungus_P2_idle_left.png, 8, 16, spr_p2_idle_left))
$(eval $(call IMG2SP, CONVERT         , assets/sprites/player2/fungus_P2_idle_right.png, 8, 16, spr_p2_idle_right))

$(eval $(call IMG2SP, CONVERT         , assets/sprites/player2/fungus_P2_run_left.png, 8, 16, spr_p2_run_left))
$(eval $(call IMG2SP, CONVERT         , assets/sprites/player2/fungus_P2_run_right.png, 8, 16, spr_p2_run_right))

$(eval $(call IMG2SP, CONVERT         , assets/sprites/player2/fungus_P2_jump_left.png, 8, 16, spr_p2_jump_left))
$(eval $(call IMG2SP, CONVERT         , assets/sprites/player2/fungus_P2_jump_right.png, 8, 16, spr_p2_jump_right))

$(eval $(call IMG2SP, CONVERT         , assets/sprites/player2/fungus_P2_die_left.png, 8, 16, spr_p2_die_left))
$(eval $(call IMG2SP, CONVERT         , assets/sprites/player2/fungus_P2_die_right.png, 8, 16, spr_p2_die_right))

$(eval $(call IMG2SP, CONVERT         , assets/sprites/player2/fungus_P2_shooting_right.png, 8, 16, spr_p2_shooting_right))
$(eval $(call IMG2SP, CONVERT         , assets/sprites/player2/fungus_P2_shooting_left.png, 8, 16, spr_p2_shooting_left))

#Bullets
$(eval $(call IMG2SP, SET_FOLDER      , src/assets/sprites/bullets))
$(eval $(call IMG2SP, CONVERT         , assets/sprites/bullets/bullet_P1.png, 6, 6, spr_p1_bullet))
$(eval $(call IMG2SP, CONVERT         , assets/sprites/bullets/bullet_P2.png, 6, 6, spr_p2_bullet))
$(eval $(call IMG2SP, CONVERT         , assets/sprites/bullets/bullet_GE.png, 6, 6, spr_ge_bullet))
$(eval $(call IMG2SP, CONVERT         , assets/sprites/bullets/bullet_GD.png, 6, 6, spr_gd_bullet))
$(eval $(call IMG2SP, CONVERT         , assets/sprites/bullets/bullet_WE.png, 6, 6, spr_we_bullet))
$(eval $(call IMG2SP, CONVERT         , assets/sprites/bullets/bullet_WD.png, 6, 6, spr_wd_bullet))


$(eval $(call IMG2SP, CONVERT         , assets/sprites/bullets/bullet_explosion.png, 6, 6, spr_bullet_anim))

#Enemies
$(eval $(call IMG2SP, SET_FOLDER      , src/assets/sprites/ghost_easy))

$(eval $(call IMG2SP, CONVERT         , assets/sprites/ghost_easy/fungus_ghost_easy_base_left.png, 8, 16, spr_ghost_easy_base_left))
$(eval $(call IMG2SP, CONVERT         , assets/sprites/ghost_easy/fungus_ghost_easy_base_right.png, 8, 16, spr_ghost_easy_base_right))

$(eval $(call IMG2SP, CONVERT         , assets/sprites/ghost_easy/fungus_ghost_easy_idle_left.png, 8, 16, spr_ghost_easy_idle_left))
$(eval $(call IMG2SP, CONVERT         , assets/sprites/ghost_easy/fungus_ghost_easy_idle_right.png, 8, 16, spr_ghost_easy_idle_right))

$(eval $(call IMG2SP, CONVERT         , assets/sprites/ghost_easy/fungus_ghost_easy_run_left.png, 8, 16, spr_ghost_easy_run_left))
$(eval $(call IMG2SP, CONVERT         , assets/sprites/ghost_easy/fungus_ghost_easy_run_right.png, 8, 16, spr_ghost_easy_run_right))

$(eval $(call IMG2SP, CONVERT         , assets/sprites/ghost_easy/fungus_ghost_easy_die_left.png, 8, 16, spr_ghost_easy_die_left))
$(eval $(call IMG2SP, CONVERT         , assets/sprites/ghost_easy/fungus_ghost_easy_die_right.png, 8, 16, spr_ghost_easy_die_right))

$(eval $(call IMG2SP, SET_FOLDER      , src/assets/sprites/ghost_difficult))

$(eval $(call IMG2SP, CONVERT         , assets/sprites/ghost_difficult/fungus_ghost_difficult_base_left.png, 8, 16, spr_ghost_difficult_base_left))
$(eval $(call IMG2SP, CONVERT         , assets/sprites/ghost_difficult/fungus_ghost_difficult_base_right.png, 8, 16, spr_ghost_difficult_base_right))

$(eval $(call IMG2SP, CONVERT         , assets/sprites/ghost_difficult/fungus_ghost_difficult_idle_left.png, 8, 16, spr_ghost_difficult_idle_left))
$(eval $(call IMG2SP, CONVERT         , assets/sprites/ghost_difficult/fungus_ghost_difficult_idle_right.png, 8, 16, spr_ghost_difficult_idle_right))

$(eval $(call IMG2SP, CONVERT         , assets/sprites/ghost_difficult/fungus_ghost_difficult_run_left.png, 8, 16, spr_ghost_difficult_run_left))
$(eval $(call IMG2SP, CONVERT         , assets/sprites/ghost_difficult/fungus_ghost_difficult_run_right.png, 8, 16, spr_ghost_difficult_run_right))

$(eval $(call IMG2SP, CONVERT         , assets/sprites/ghost_difficult/fungus_ghost_difficult_die_left.png, 8, 16, spr_ghost_difficult_die_left))
$(eval $(call IMG2SP, CONVERT         , assets/sprites/ghost_difficult/fungus_ghost_difficult_die_right.png, 8, 16, spr_ghost_difficult_die_right))

$(eval $(call IMG2SP, SET_FOLDER      , src/assets/sprites/walker_easy))

$(eval $(call IMG2SP, CONVERT         , assets/sprites/walker_easy/fungus_walker_easy_base_left.png, 8, 16, spr_walker_easy_base_left))
$(eval $(call IMG2SP, CONVERT         , assets/sprites/walker_easy/fungus_walker_easy_base_right.png, 8, 16, spr_walker_easy_base_right))

$(eval $(call IMG2SP, CONVERT         , assets/sprites/walker_easy/fungus_walker_easy_idle_left.png, 8, 16, spr_walker_easy_idle_left))
$(eval $(call IMG2SP, CONVERT         , assets/sprites/walker_easy/fungus_walker_easy_idle_right.png, 8, 16, spr_walker_easy_idle_right))

$(eval $(call IMG2SP, CONVERT         , assets/sprites/walker_easy/fungus_walker_easy_run_left.png, 8, 16, spr_walker_easy_run_left))
$(eval $(call IMG2SP, CONVERT         , assets/sprites/walker_easy/fungus_walker_easy_run_right.png, 8, 16, spr_walker_easy_run_right))

$(eval $(call IMG2SP, CONVERT         , assets/sprites/walker_easy/fungus_walker_easy_jump_left.png, 8, 16, spr_walker_easy_jump_left))
$(eval $(call IMG2SP, CONVERT         , assets/sprites/walker_easy/fungus_walker_easy_jump_right.png, 8, 16, spr_walker_easy_jump_right))

$(eval $(call IMG2SP, CONVERT         , assets/sprites/walker_easy/fungus_walker_easy_die_left.png, 8, 16, spr_walker_easy_die_left))
$(eval $(call IMG2SP, CONVERT         , assets/sprites/walker_easy/fungus_walker_easy_die_right.png, 8, 16, spr_walker_easy_die_right))

$(eval $(call IMG2SP, CONVERT         , assets/sprites/walker_easy/fungus_walker_easy_shooting_right.png, 8, 16, spr_walker_easy_shooting_right))
$(eval $(call IMG2SP, CONVERT         , assets/sprites/walker_easy/fungus_walker_easy_shooting_left.png, 8, 16, spr_walker_easy_shooting_left))



$(eval $(call IMG2SP, SET_FOLDER      , src/assets/sprites/walker_difficult))

$(eval $(call IMG2SP, CONVERT         , assets/sprites/walker_difficult/fungus_walker_difficult_base_left.png, 8, 16, spr_walker_difficult_base_left))
$(eval $(call IMG2SP, CONVERT         , assets/sprites/walker_difficult/fungus_walker_difficult_base_right.png, 8, 16, spr_walker_difficult_base_right))

$(eval $(call IMG2SP, CONVERT         , assets/sprites/walker_difficult/fungus_walker_difficult_idle_left.png, 8, 16, spr_walker_difficult_idle_left))
$(eval $(call IMG2SP, CONVERT         , assets/sprites/walker_difficult/fungus_walker_difficult_idle_right.png, 8, 16, spr_walker_difficult_idle_right))

$(eval $(call IMG2SP, CONVERT         , assets/sprites/walker_difficult/fungus_walker_difficult_run_left.png, 8, 16, spr_walker_difficult_run_left))
$(eval $(call IMG2SP, CONVERT         , assets/sprites/walker_difficult/fungus_walker_difficult_run_right.png, 8, 16, spr_walker_difficult_run_right))

$(eval $(call IMG2SP, CONVERT         , assets/sprites/walker_difficult/fungus_walker_difficult_jump_left.png, 8, 16, spr_walker_difficult_jump_left))
$(eval $(call IMG2SP, CONVERT         , assets/sprites/walker_difficult/fungus_walker_difficult_jump_right.png, 8, 16, spr_walker_difficult_jump_right))

$(eval $(call IMG2SP, CONVERT         , assets/sprites/walker_difficult/fungus_walker_difficult_die_left.png, 8, 16, spr_walker_difficult_die_left))
$(eval $(call IMG2SP, CONVERT         , assets/sprites/walker_difficult/fungus_walker_difficult_die_right.png, 8, 16, spr_walker_difficult_die_right))

#Platforms
$(eval $(call IMG2SP, SET_FOLDER      , src/assets/sprites/platforms/platform_grass))
$(eval $(call IMG2SP, CONVERT         , assets/sprites/platforms/platform_grass/platform_grass.png, 24, 8, spr_platform_grass))

$(eval $(call IMG2SP, SET_FOLDER      , src/assets/sprites/platforms/platform_grass_rocks))
$(eval $(call IMG2SP, CONVERT         , assets/sprites/platforms/platform_grass_rocks/platform_grass_rocks_24.png, 24, 8, spr_platform_grass_rocks))
$(eval $(call IMG2SP, SET_FOLDER      , src/assets/sprites/platforms/platform_grass_rocks))
$(eval $(call IMG2SP, CONVERT         , assets/sprites/platforms/platform_grass_rocks/platform_grass_rocks_small.png, 8, 8, spr_platform_grass_rocks_small))

$(eval $(call IMG2SP, SET_FOLDER      , src/assets/sprites/platforms/platform_rocks_grass))
$(eval $(call IMG2SP, CONVERT         , assets/sprites/platforms/platform_rocks_grass/platform_rocks_grass.png, 24, 8, spr_platform_rocks_grass))
$(eval $(call IMG2SP, SET_FOLDER      , src/assets/sprites/platforms/platform_rocks_grass))
$(eval $(call IMG2SP, CONVERT         , assets/sprites/platforms/platform_rocks_grass/platform_rocks_grass_small.png, 8, 8, spr_platform_rocks_grass_small))

$(eval $(call IMG2SP, SET_FOLDER      , src/assets/sprites/platforms/platform_rocks))
$(eval $(call IMG2SP, CONVERT         , assets/sprites/platforms/platform_rocks/platform_rocks.png, 24, 8, spr_platform_rocks))
$(eval $(call IMG2SP, SET_FOLDER      , src/assets/sprites/platforms/platform_rocks))
$(eval $(call IMG2SP, CONVERT         , assets/sprites/platforms/platform_rocks/platform_rocks_small.png, 8, 8, spr_platform_rocks_small))

#Intergame frame
$(eval $(call IMG2SP, SET_FOLDER      , src/assets/sprites/intergame))
$(eval $(call IMG2SP, CONVERT         , assets/sprites/intergame/intergame_frame_left_side.png, 6, 64, spr_intergame_frame_left_side))

$(eval $(call IMG2SP, SET_FOLDER      , src/assets/sprites/intergame))
$(eval $(call IMG2SP, CONVERT         , assets/sprites/intergame/intergame_frame_right_side.png, 6, 64, spr_intergame_frame_right_side))

$(eval $(call IMG2SP, SET_FOLDER      , src/assets/sprites/intergame))
$(eval $(call IMG2SP, CONVERT         , assets/sprites/intergame/intergame_frame_top_left.png, 64, 6, spr_intergame_frame_top_left))

$(eval $(call IMG2SP, SET_FOLDER      , src/assets/sprites/intergame))
$(eval $(call IMG2SP, CONVERT         , assets/sprites/intergame/intergame_frame_top_right.png, 64, 6, spr_intergame_frame_top_right))

$(eval $(call IMG2SP, SET_FOLDER      , src/assets/sprites/intergame))
$(eval $(call IMG2SP, CONVERT         , assets/sprites/intergame/intergame_frame_down_left.png, 64, 6, spr_intergame_frame_down_left))

$(eval $(call IMG2SP, SET_FOLDER      , src/assets/sprites/intergame))
$(eval $(call IMG2SP, CONVERT         , assets/sprites/intergame/intergame_frame_down_right.png, 64, 6, spr_intergame_frame_down_right))

#Controls
$(eval $(call IMG2SP, SET_FOLDER      , src/assets/img))
$(eval $(call IMG2SP, SET_IMG_FORMAT  , screen            ))
$(eval $(call IMG2SP, SET_OUTPUT      , bin                  ))
$(eval $(call IMG2SP, CONVERT         , assets/images/controls.png, 0, 0, controls))

$(eval $(call IMG2SP, SET_FOLDER      , src/assets/img))
$(eval $(call IMG2SP, SET_IMG_FORMAT  , screen            ))
$(eval $(call IMG2SP, SET_OUTPUT      , bin                  ))
$(eval $(call IMG2SP, CONVERT         , assets/images/controls_player.png, 0, 0, controls_player))

$(eval $(call IMG2SP, SET_FOLDER      , src/assets/img))
$(eval $(call IMG2SP, SET_IMG_FORMAT  , screen            ))
$(eval $(call IMG2SP, SET_OUTPUT      , bin                  ))
$(eval $(call IMG2SP, CONVERT         , assets/images/controls_bullet.png, 0, 0, controls_bullet))

$(eval $(call IMG2SP, SET_FOLDER      , src/assets/img))
$(eval $(call IMG2SP, SET_IMG_FORMAT  , screen            ))
$(eval $(call IMG2SP, SET_OUTPUT      , bin                  ))
$(eval $(call IMG2SP, CONVERT         , assets/images/menu_fondo.png, 0, 0, menu))

$(eval $(call IMG2SP, SET_FOLDER      , src/assets/img))
$(eval $(call IMG2SP, SET_IMG_FORMAT  , screen            ))
$(eval $(call IMG2SP, SET_OUTPUT      , bin                  ))
$(eval $(call IMG2SP, CONVERT         , assets/images/main_game.png, 0, 0, maingame))

$(eval $(call IMG2SP, SET_FOLDER      , src/assets/img))
$(eval $(call IMG2SP, SET_IMG_FORMAT  , screen            ))
$(eval $(call IMG2SP, SET_OUTPUT      , bin                  ))
$(eval $(call IMG2SP, CONVERT         , assets/images/main_game_1.png, 0, 0, maingame_1))

$(eval $(call IMG2SP, SET_FOLDER      , src/assets/img))
$(eval $(call IMG2SP, SET_IMG_FORMAT  , screen            ))
$(eval $(call IMG2SP, SET_OUTPUT      , bin                  ))
$(eval $(call IMG2SP, CONVERT         , assets/images/main_game_2.png, 0, 0, maingame_2))

$(eval $(call IMG2SP, SET_FOLDER      , src/assets/img))
$(eval $(call IMG2SP, SET_IMG_FORMAT  , screen            ))
$(eval $(call IMG2SP, SET_OUTPUT      , bin                  ))
$(eval $(call IMG2SP, CONVERT         , assets/images/main_game_3.png, 0, 0, maingame_3))

$(eval $(call IMG2SP, SET_FOLDER      , src/assets/img))
$(eval $(call IMG2SP, SET_IMG_FORMAT  , screen            ))
$(eval $(call IMG2SP, SET_OUTPUT      , bin                  ))
$(eval $(call IMG2SP, CONVERT         , assets/images/you_win_screen.png, 0, 0, win_screen))

$(eval $(call IMG2SP, SET_FOLDER      , src/assets/img))
$(eval $(call IMG2SP, SET_IMG_FORMAT  , screen            ))
$(eval $(call IMG2SP, SET_OUTPUT      , bin                  ))
$(eval $(call IMG2SP, CONVERT         , assets/images/you_lose_screen.png, 0, 0, lose_screen))

##
## OLD MACROS (For compatibility)
##

## Example firmware palette definition as variable in cpct_img2tileset format

# PALETTE={0 1 3 4 7 9 10 12 13 16 19 20 21 24 25 26}

## AUTOMATED IMAGE CONVERSION EXAMPLE (Uncomment EVAL line to use)
##
##    This example would convert img/example.png into src/example.{c|h} files.
##    A C-array called pre_example[24*12*2] would be generated with the definition
##    of the image example.png in mode 0 screen pixel format, with interlaced mask.
##    The palette used for conversion is given through the PALETTE variable and
##    a pre_palette[16] array will be generated with the 16 palette colours as 
##	  hardware colour values.

#$(eval $(call IMG2SPRITES,img/example.png,0,pre,24,12,$(PALETTE),mask,src/,hwpalette))



############################################################################
##              DETAILED INSTRUCTIONS AND PARAMETERS                      ##
##------------------------------------------------------------------------##
##                                                                        ##
## Macro used for conversion is IMG2SPRITES, which has up to 9 parameters:##
##  (1): Image file to be converted into C sprite (PNG, JPG, GIF, etc)    ##
##  (2): Graphics mode (0,1,2) for the generated C sprite                 ##
##  (3): Prefix to add to all C-identifiers generated                     ##
##  (4): Width in pixels of each sprite/tile/etc that will be generated   ##
##  (5): Height in pixels of each sprite/tile/etc that will be generated  ##
##  (6): Firmware palette used to convert the image file into C values    ##
##  (7): (mask / tileset / zgtiles)                                       ##
##     - "mask":    generate interlaced mask for all sprites converted    ##
##     - "tileset": generate a tileset array with pointers to all sprites ##
##     - "zgtiles": generate tiles/sprites in Zig-Zag pixel order and     ##
##                  Gray Code row order                                   ##
##  (8): Output subfolder for generated .C/.H files (in project folder)   ##
##  (9): (hwpalette)                                                      ##
##     - "hwpalette": output palette array with hardware colour values    ##
## (10): Aditional options (you can use this to pass aditional modifiers  ##
##       to cpct_img2tileset)                                             ##
##                                                                        ##
## Macro is used in this way (one line for each image to be converted):   ##
##  $(eval $(call IMG2SPRITES,(1),(2),(3),(4),(5),(6),(7),(8),(9), (10))) ##
##                                                                        ##
## Important:                                                             ##
##  * Do NOT separate macro parameters with spaces, blanks or other chars.##
##    ANY character you put into a macro parameter will be passed to the  ##
##    macro. Therefore ...,src/sprites,... will represent "src/sprites"   ##
##    folder, whereas ...,  src/sprites,... means "  src/sprites" folder. ##
##                                                                        ##
##  * You can omit parameters but leaving them empty. Therefore, if you   ##
##  wanted to specify an output folder but do not want your sprites to    ##
##  have mask and/or tileset, you may omit parameter (7) leaving it empty ##
##     $(eval $(call IMG2SPRITES,imgs/1.png,0,g,4,8,$(PAL),,src/))        ##
############################################################################
