;;-----------------------------LICENSE NOTICE------------------------------------
;;  This file is part of The Last Fungus: An Amstrad CPC Game 
;;  Copyright (C) 2021 Miguel Perez Tarruella / Antonio Jose Fernandez Belliure / 
;;                     David Martinez Garcia / Ocacho Games (@OcachoGames)
;;
;;  This program is free software: you can redistribute it and/or modify
;;  it under the terms of the GNU Lesser General Public License as published by
;;  the Free Software Foundation, either version 3 of the License, or
;;  (at your option) any later version.
;;
;;  This program is distributed in the hope that it will be useful,
;;  but WITHOUT ANY WARRANTY; without even the implied warranty of
;;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;  GNU Lesser General Public License for more details.
;;
;;  You should have received a copy of the GNU Lesser General Public License
;;  along with this program.  If not, see <http://www.gnu.org/licenses/>.
;;------------------------------------------------------------------------------

;;====================================================================
;; CPCTELERA INCLUDES 
;;====================================================================

;;Utilities
.globl cpct_memset_asm
.globl cpct_memcpy_asm
.globl cpct_zx7b_decrunch_s_asm

;;Randoms
.globl cpct_getRandom_mxor_u8_asm
.globl cpct_getRandom_xsp40_u8_asm

;;Video
.globl cpct_getScreenPtr_asm
.globl cpct_drawSprite_asm
.globl cpct_drawSolidBox_asm
.globl cpct_setVideoMode_asm
.globl cpct_setPalette_asm
.globl cpct_setPALColour_asm

;;Strings
.globl cpct_setDrawCharM0_asm
.globl cpct_drawStringM0_asm

;;Time
.globl cpct_waitVSYNC_asm
.globl cpct_waitVSYNCStart_asm

;;Music
.globl cpct_akp_musicInit_asm
.globl cpct_akp_musicPlay_asm
.globl cpct_akp_stop_asm
.globl cpct_akp_setFadeVolume_asm

;;Keyboard
.globl cpct_scanKeyboard_if_asm
.globl cpct_isKeyPressed_asm

;;====================================================================
;; KEYBOARD - KEYS
;;====================================================================

;;Player 1
.globl Key_A                
.globl Key_D                
.globl Key_W   
.globl Key_S             

;;Player 2
.globl Key_J                
.globl Key_L                
.globl Key_I                
.globl Key_Space               

;;Menu
.globl Key_1        ;; Player vs AI
.globl Key_2        ;; Player vs Player
.globl Key_3        ;; Controls
.globl Key_Space    ;; Play again
.globl Key_Esc      ;; Back to menu

;;====================================================================
;; GLOBAL VARIABLES INCLUDES
;;====================================================================
.globl jump_force

