;;-----------------------------LICENSE NOTICE------------------------------------
;;  This file is part of The Last Fungus: An Amstrad CPC Game 
;;  Copyright (C) 2021 Miguel Perez Tarruella / Antonio Jose Fernandez Belliure / 
;;                     David Martinez Garcia / Ocacho Games (@OcachoGames)
;;
;;  This program is free software: you can redistribute it and/or modify
;;  it under the terms of the GNU Lesser General Public License as published by
;;  the Free Software Foundation, either version 3 of the License, or
;;  (at your option) any later version.
;;
;;  This program is distributed in the hope that it will be useful,
;;  but WITHOUT ANY WARRANTY; without even the implied warranty of
;;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;  GNU Lesser General Public License for more details.
;;
;;  You should have received a copy of the GNU Lesser General Public License
;;  along with this program.  If not, see <http://www.gnu.org/licenses/>.
;;------------------------------------------------------------------------------

.include "sprites.h.s"

;;====================================================================
;; ANIMATIONS
;;====================================================================

;;====================================================================
;; WALKER EASY
;;====================================================================

;;====================================================================
;; IDLE
;;====================================================================

walker_easy_idle_left:
    .db #8
    .dw _spr_walker_easy_base_left
    .db #8
    .dw _spr_walker_easy_idle_left
    .db #0
    .dw #walker_easy_idle_left

walker_easy_idle_right:
    .db #8
    .dw _spr_walker_easy_base_right
    .db #8
    .dw _spr_walker_easy_idle_right
    .db #0
    .dw #walker_easy_idle_right

;;====================================================================
;; RUN
;;====================================================================

walker_easy_run_left:
    .db #4
    .dw _spr_walker_easy_base_left
    .db #4
    .dw _spr_walker_easy_run_left_0
    .db #4
    .dw _spr_walker_easy_base_left
    .db #4
    .dw _spr_walker_easy_run_left_1
    .db #0
    .dw #walker_easy_run_left

walker_easy_run_right:
    .db #4
    .dw _spr_walker_easy_base_right
    .db #4
    .dw _spr_walker_easy_run_right_0
    .db #4
    .dw _spr_walker_easy_base_right
    .db #4
    .dw _spr_walker_easy_run_right_1
    .db #0
    .dw #walker_easy_run_right

;;====================================================================
;; JUMP
;;====================================================================

walker_easy_jump_left:
    .db #4
    .dw _spr_walker_easy_jump_left_0
    .db #40
    .dw _spr_walker_easy_jump_left_1
    .db #0
    .dw #walker_easy_jump_left

walker_easy_jump_right:
    .db #4
    .dw _spr_walker_easy_jump_right_0
    .db #40
    .dw _spr_walker_easy_jump_right_1
    .db #0
    .dw #walker_easy_jump_right

;;====================================================================
;; DIE
;;====================================================================

walker_easy_die_left:
    .db #8
    .dw _spr_walker_easy_die_left_0
    .db #8
    .dw _spr_walker_easy_die_left_1
    .db #8
    .dw _spr_walker_easy_die_left_2
    .db #8
    .dw _spr_walker_easy_die_left_3
    .db #0
    .dw #walker_easy_die_left

walker_easy_die_right:
    .db #8
    .dw _spr_walker_easy_die_right_0
    .db #8
    .dw _spr_walker_easy_die_right_1
    .db #8
    .dw _spr_walker_easy_die_right_2
    .db #8
    .dw _spr_walker_easy_die_right_3
    .db #0
    .dw #walker_easy_die_right

;;====================================================================
;; SHOOTING
;;====================================================================

walker_easy_shooting_left:
    .db #8
    .dw _spr_walker_easy_shooting_left_0
    .db #8
    .dw _spr_walker_easy_shooting_left_1
    .db #0
    .dw #walker_easy_shooting_left

walker_easy_shooting_right:
    .db #8
    .dw _spr_walker_easy_shooting_right_0
    .db #8
    .dw _spr_walker_easy_shooting_right_1
    .db #0
    .dw #walker_easy_shooting_right

;;====================================================================
;; WALKER DIFFICULT
;;====================================================================

;;====================================================================
;; IDLE
;;====================================================================

walker_difficult_idle_left:
    .db #8
    .dw _spr_walker_difficult_base_left
    .db #8
    .dw _spr_walker_difficult_idle_left
    .db #0
    .dw #walker_difficult_idle_left

walker_difficult_idle_right:
    .db #8
    .dw _spr_walker_difficult_base_right
    .db #8
    .dw _spr_walker_difficult_idle_right
    .db #0
    .dw #walker_difficult_idle_right

;;====================================================================
;; RUN
;;====================================================================

walker_difficult_run_left:
    .db #4
    .dw _spr_walker_difficult_base_left
    .db #4
    .dw _spr_walker_difficult_run_left_0
    .db #4
    .dw _spr_walker_difficult_base_left
    .db #4
    .dw _spr_walker_difficult_run_left_1
    .db #0
    .dw #walker_difficult_run_left

walker_difficult_run_right:
    .db #4
    .dw _spr_walker_difficult_base_right
    .db #4
    .dw _spr_walker_difficult_run_right_0
    .db #4
    .dw _spr_walker_difficult_base_right
    .db #4
    .dw _spr_walker_difficult_run_right_1
    .db #0
    .dw #walker_difficult_run_right

;;====================================================================
;; JUMP
;;====================================================================

walker_difficult_jump_left:
    .db #4
    .dw _spr_walker_difficult_jump_left_0
    .db #40
    .dw _spr_walker_difficult_jump_left_1
    .db #0
    .dw #walker_difficult_jump_left

walker_difficult_jump_right:
    .db #4
    .dw _spr_walker_difficult_jump_right_0
    .db #40
    .dw _spr_walker_difficult_jump_right_1
    .db #0
    .dw #walker_difficult_jump_right


;;====================================================================
;; DIE
;;====================================================================

walker_difficult_die_left:
    .db #8
    .dw _spr_walker_difficult_die_left_0
    .db #8
    .dw _spr_walker_difficult_die_left_1
    .db #8
    .dw _spr_walker_difficult_die_left_2
    .db #8
    .dw _spr_walker_difficult_die_left_3
    .db #0
    .dw #walker_difficult_die_left

walker_difficult_die_right:
    .db #8
    .dw _spr_walker_difficult_die_right_0
    .db #8
    .dw _spr_walker_difficult_die_right_1
    .db #8
    .dw _spr_walker_difficult_die_right_2
    .db #8
    .dw _spr_walker_difficult_die_right_3
    .db #0
    .dw #walker_difficult_die_right

;;====================================================================
;; SHOOTING
;;====================================================================

walker_difficult_shooting_left:
    .db #8
    .dw _spr_walker_difficult_base_left
    .db #0
    .dw #walker_difficult_shooting_left

walker_difficult_shooting_right:
    .db #8
    .dw _spr_walker_difficult_base_right
    .db #0
    .dw #walker_difficult_shooting_right

;;====================================================================
;; GHOST EASY
;;====================================================================

;;====================================================================
;; IDLE
;;====================================================================

ghost_easy_idle_left:
    .db #8
    .dw _spr_ghost_easy_base_left
    .db #8
    .dw _spr_ghost_easy_idle_left
    .db #0
    .dw #ghost_easy_idle_left

ghost_easy_idle_right:
    .db #8
    .dw _spr_ghost_easy_base_right
    .db #8
    .dw _spr_ghost_easy_idle_right
    .db #0
    .dw #ghost_easy_idle_right

;;====================================================================
;; RUN
;;====================================================================

ghost_easy_run_left:
    .db #8
    .dw _spr_ghost_easy_base_left
    .db #8
    .dw _spr_ghost_easy_run_left
    .db #0
    .dw #ghost_easy_run_left

ghost_easy_run_right:
    .db #8
    .dw _spr_ghost_easy_base_right
    .db #8
    .dw _spr_ghost_easy_run_right
    .db #0
    .dw #ghost_easy_run_right

;;====================================================================
;; DIE
;;====================================================================

ghost_easy_die_left:
    .db #8
    .dw _spr_ghost_easy_die_left_0
    .db #8
    .dw _spr_ghost_easy_die_left_1
    .db #8
    .dw _spr_ghost_easy_die_left_2
    .db #0
    .dw #ghost_easy_die_left

ghost_easy_die_right:
    .db #8
    .dw _spr_ghost_easy_die_right_0
    .db #8
    .dw _spr_ghost_easy_die_right_1
    .db #8
    .dw _spr_ghost_easy_die_right_2
    .db #0
    .dw #ghost_easy_die_right

;;====================================================================
;; GHOST DIFFICULT
;;====================================================================

;;====================================================================
;; IDLE
;;====================================================================

ghost_difficult_idle_left:
    .db #8
    .dw _spr_ghost_difficult_base_left
    .db #8
    .dw _spr_ghost_difficult_idle_left
    .db #0
    .dw #ghost_difficult_idle_left

ghost_difficult_idle_right:
    .db #8
    .dw _spr_ghost_difficult_base_right
    .db #8
    .dw _spr_ghost_difficult_idle_right
    .db #0
    .dw #ghost_difficult_idle_right

;;====================================================================
;; RUN
;;====================================================================

ghost_difficult_run_left:
    .db #8
    .dw _spr_ghost_difficult_base_left
    .db #8
    .dw _spr_ghost_difficult_run_left
    .db #0
    .dw #ghost_difficult_run_left

ghost_difficult_run_right:
    .db #8
    .dw _spr_ghost_difficult_base_right
    .db #8
    .dw _spr_ghost_difficult_run_right
    .db #0
    .dw #ghost_difficult_run_right

;;====================================================================
;; DIE
;;====================================================================

ghost_difficult_die_left:
    .db #8
    .dw _spr_ghost_difficult_die_left_0
    .db #8
    .dw _spr_ghost_difficult_die_left_1
    .db #8
    .dw _spr_ghost_difficult_die_left_2
    .db #0
    .dw #ghost_difficult_die_left

ghost_difficult_die_right:
    .db #8
    .dw _spr_ghost_difficult_die_right_0
    .db #8
    .dw _spr_ghost_difficult_die_right_1
    .db #8
    .dw _spr_ghost_difficult_die_right_2
    .db #0
    .dw #ghost_difficult_die_right
