;;-----------------------------LICENSE NOTICE------------------------------------
;;  This file is part of The Last Fungus: An Amstrad CPC Game 
;;  Copyright (C) 2021 Miguel Perez Tarruella / Antonio Jose Fernandez Belliure / 
;;                     David Martinez Garcia / Ocacho Games (@OcachoGames)
;;
;;  This program is free software: you can redistribute it and/or modify
;;  it under the terms of the GNU Lesser General Public License as published by
;;  the Free Software Foundation, either version 3 of the License, or
;;  (at your option) any later version.
;;
;;  This program is distributed in the hope that it will be useful,
;;  but WITHOUT ANY WARRANTY; without even the implied warranty of
;;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;  GNU Lesser General Public License for more details.
;;
;;  You should have received a copy of the GNU Lesser General Public License
;;  along with this program.  If not, see <http://www.gnu.org/licenses/>.
;;------------------------------------------------------------------------------

.include "sprites.h.s"

;;====================================================================
;; ANIMATIONS
;;====================================================================

;;====================================================================
;; PLAYER 1
;;====================================================================

;;====================================================================
;; IDLE
;;====================================================================

player1_idle_left:
    .db #8
    .dw _spr_p1_base_left
    .db #8
    .dw _spr_p1_idle_left
    .db #0
    .dw #player1_idle_left

player1_idle_right:
    .db #8
    .dw _spr_p1_base_right
    .db #8
    .dw _spr_p1_idle_right
    .db #0
    .dw #player1_idle_right

;;====================================================================
;; RUN
;;====================================================================

player1_run_left:
    .db #4
    .dw _spr_p1_base_left
    .db #4
    .dw _spr_p1_run_left_0
    .db #4
    .dw _spr_p1_base_left
    .db #4
    .dw _spr_p1_run_left_1
    .db #0
    .dw #player1_run_left

player1_run_right:
    .db #4
    .dw _spr_p1_base_right
    .db #4
    .dw _spr_p1_run_right_0
    .db #4
    .dw _spr_p1_base_right
    .db #4
    .dw _spr_p1_run_right_1
    .db #0
    .dw #player1_run_right

;;====================================================================
;; JUMP
;;====================================================================

player1_jump_left:
    .db #4
    .dw _spr_p1_jump_left_0
    .db #40
    .dw _spr_p1_jump_left_1
    .db #0
    .dw #player1_jump_left

player1_jump_right:
    .db #4
    .dw _spr_p1_jump_right_0
    .db #40
    .dw _spr_p1_jump_right_1
    .db #0
    .dw #player1_jump_right

;;====================================================================
;; DIE
;;====================================================================

player1_die_left:
    .db #8
    .dw _spr_p1_die_left_0
    .db #8
    .dw _spr_p1_die_left_1
    .db #8
    .dw _spr_p1_die_left_2
    .db #8
    .dw _spr_p1_die_left_3
    .db #0
    .dw #player1_die_left

player1_die_right:
    .db #8
    .dw _spr_p1_die_right_0
    .db #8
    .dw _spr_p1_die_right_1
    .db #8
    .dw _spr_p1_die_right_2
    .db #8
    .dw _spr_p1_die_right_3
    .db #0
    .dw #player1_die_right

;;====================================================================
;; SHOOTING
;;====================================================================

player1_shooting_left:
    .db #8
    .dw _spr_p1_shooting_left_0
    .db #8
    .dw _spr_p1_shooting_left_1
    .db #0
    .dw #player1_shooting_left

player1_shooting_right:
    .db #8
    .dw _spr_p1_shooting_right_0
    .db #8
    .dw _spr_p1_shooting_right_1
    .db #0
    .dw #player1_shooting_right

;;====================================================================
;; PLAYER 2 / ENEMY Ai
;;====================================================================

;;====================================================================
;; IDLE
;;====================================================================

player2_idle_left:
    .db #8
    .dw _spr_p2_base_left
    .db #8
    .dw _spr_p2_idle_left
    .db #0
    .dw #player2_idle_left

player2_idle_right:
    .db #8
    .dw _spr_p2_base_right
    .db #8
    .dw _spr_p2_idle_right
    .db #0
    .dw #player2_idle_right

;;====================================================================
;; RUN
;;====================================================================

player2_run_left:
    .db #4
    .dw _spr_p2_base_left
    .db #4
    .dw _spr_p2_run_left_0
    .db #4
    .dw _spr_p2_base_left
    .db #4
    .dw _spr_p2_run_left_1
    .db #0
    .dw #player2_run_left

player2_run_right:
    .db #4
    .dw _spr_p2_base_right
    .db #4
    .dw _spr_p2_run_right_0
    .db #4
    .dw _spr_p2_base_right
    .db #4
    .dw _spr_p2_run_right_1
    .db #0
    .dw #player2_run_right

;;====================================================================
;; JUMP
;;====================================================================

player2_jump_left:
    .db #4
    .dw _spr_p2_jump_left_0
    .db #40
    .dw _spr_p2_jump_left_1
    .db #0
    .dw #player2_jump_left

player2_jump_right:
    .db #4
    .dw _spr_p2_jump_right_0
    .db #40
    .dw _spr_p2_jump_right_1
    .db #0
    .dw #player2_jump_right


;;====================================================================
;; DIE
;;====================================================================

player2_die_left:
    .db #8
    .dw _spr_p2_die_left_0
    .db #8
    .dw _spr_p2_die_left_1
    .db #8
    .dw _spr_p2_die_left_2
    .db #8
    .dw _spr_p2_die_left_3
    .db #0
    .dw #player2_die_left

player2_die_right:
    .db #8
    .dw _spr_p2_die_right_0
    .db #8
    .dw _spr_p2_die_right_1
    .db #8
    .dw _spr_p2_die_right_2
    .db #8
    .dw _spr_p2_die_right_3
    .db #0
    .dw #player2_die_right

;;====================================================================
;; SHOOTING
;;====================================================================

player2_shooting_left:
    .db #8
    .dw _spr_p2_shooting_left_0
    .db #8
    .dw _spr_p2_shooting_left_1
    .db #0
    .dw #player2_shooting_left

player2_shooting_right:
    .db #8
    .dw _spr_p2_shooting_right_0
    .db #8
    .dw _spr_p2_shooting_right_1
    .db #0
    .dw #player2_shooting_right
