;;-----------------------------LICENSE NOTICE------------------------------------
;;  This file is part of The Last Fungus: An Amstrad CPC Game 
;;  Copyright (C) 2021 Miguel Perez Tarruella / Antonio Jose Fernandez Belliure / 
;;                     David Martinez Garcia / Ocacho Games (@OcachoGames)
;;
;;  This program is free software: you can redistribute it and/or modify
;;  it under the terms of the GNU Lesser General Public License as published by
;;  the Free Software Foundation, either version 3 of the License, or
;;  (at your option) any later version.
;;
;;  This program is distributed in the hope that it will be useful,
;;  but WITHOUT ANY WARRANTY; without even the implied warranty of
;;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;  GNU Lesser General Public License for more details.
;;
;;  You should have received a copy of the GNU Lesser General Public License
;;  along with this program.  If not, see <http://www.gnu.org/licenses/>.
;;------------------------------------------------------------------------------

;;====================================================================
;; PUBLIC INCLUDES
;;====================================================================

;;Player1
.globl _spr_p1_base_left
.globl _spr_p1_base_right

.globl _spr_p1_idle_left
.globl _spr_p1_idle_right

.globl _spr_p1_run_left_0
.globl _spr_p1_run_left_1
.globl _spr_p1_run_right_0
.globl _spr_p1_run_right_1

.globl _spr_p1_jump_left_0
.globl _spr_p1_jump_left_1
.globl _spr_p1_jump_right_0
.globl _spr_p1_jump_right_1

.globl _spr_p1_die_left_0
.globl _spr_p1_die_left_1
.globl _spr_p1_die_left_2
.globl _spr_p1_die_left_3
.globl _spr_p1_die_right_0
.globl _spr_p1_die_right_1
.globl _spr_p1_die_right_2
.globl _spr_p1_die_right_3

.globl _spr_p1_shooting_left_0
.globl _spr_p1_shooting_left_1
.globl _spr_p1_shooting_right_0
.globl _spr_p1_shooting_right_1

;;Player2
.globl _spr_p2_base_left
.globl _spr_p2_base_right

.globl _spr_p2_idle_left
.globl _spr_p2_idle_right

.globl _spr_p2_run_left_0
.globl _spr_p2_run_left_1
.globl _spr_p2_run_right_0
.globl _spr_p2_run_right_1

.globl _spr_p2_jump_left_0
.globl _spr_p2_jump_left_1
.globl _spr_p2_jump_right_0
.globl _spr_p2_jump_right_1

.globl _spr_p2_die_left_0
.globl _spr_p2_die_left_1
.globl _spr_p2_die_left_2
.globl _spr_p2_die_left_3
.globl _spr_p2_die_right_0
.globl _spr_p2_die_right_1
.globl _spr_p2_die_right_2
.globl _spr_p2_die_right_3

.globl _spr_p2_shooting_left_0
.globl _spr_p2_shooting_left_1
.globl _spr_p2_shooting_right_0
.globl _spr_p2_shooting_right_1

;;Enemies
;;Walker easy
.globl _spr_walker_easy_base_left
.globl _spr_walker_easy_base_right

.globl _spr_walker_easy_idle_left
.globl _spr_walker_easy_idle_right

.globl _spr_walker_easy_run_left_0
.globl _spr_walker_easy_run_left_1
.globl _spr_walker_easy_run_right_0
.globl _spr_walker_easy_run_right_1

.globl _spr_walker_easy_jump_left_0
.globl _spr_walker_easy_jump_left_1
.globl _spr_walker_easy_jump_right_0
.globl _spr_walker_easy_jump_right_1

.globl _spr_walker_easy_die_left_0
.globl _spr_walker_easy_die_left_1
.globl _spr_walker_easy_die_left_2
.globl _spr_walker_easy_die_left_3
.globl _spr_walker_easy_die_right_0
.globl _spr_walker_easy_die_right_1
.globl _spr_walker_easy_die_right_2
.globl _spr_walker_easy_die_right_3

.globl _spr_walker_easy_shooting_left_0
.globl _spr_walker_easy_shooting_left_1
.globl _spr_walker_easy_shooting_right_0
.globl _spr_walker_easy_shooting_right_1


;;Walker difficult
.globl _spr_walker_difficult_base_left
.globl _spr_walker_difficult_base_right

.globl _spr_walker_difficult_idle_left
.globl _spr_walker_difficult_idle_right

.globl _spr_walker_difficult_run_left_0
.globl _spr_walker_difficult_run_left_1
.globl _spr_walker_difficult_run_right_0
.globl _spr_walker_difficult_run_right_1

.globl _spr_walker_difficult_jump_left_0
.globl _spr_walker_difficult_jump_left_1
.globl _spr_walker_difficult_jump_right_0
.globl _spr_walker_difficult_jump_right_1

.globl _spr_walker_difficult_die_left_0
.globl _spr_walker_difficult_die_left_1
.globl _spr_walker_difficult_die_left_2
.globl _spr_walker_difficult_die_left_3
.globl _spr_walker_difficult_die_right_0
.globl _spr_walker_difficult_die_right_1
.globl _spr_walker_difficult_die_right_2
.globl _spr_walker_difficult_die_right_3

;;Ghost easy
.globl _spr_ghost_easy_base_left
.globl _spr_ghost_easy_base_right

.globl _spr_ghost_easy_idle_left
.globl _spr_ghost_easy_idle_right

.globl _spr_ghost_easy_run_left
.globl _spr_ghost_easy_run_right

.globl _spr_ghost_easy_die_left_0
.globl _spr_ghost_easy_die_left_1
.globl _spr_ghost_easy_die_left_2
.globl _spr_ghost_easy_die_right_0
.globl _spr_ghost_easy_die_right_1
.globl _spr_ghost_easy_die_right_2

;;Ghost difficult
.globl _spr_ghost_difficult_base_left
.globl _spr_ghost_difficult_base_right

.globl _spr_ghost_difficult_idle_left
.globl _spr_ghost_difficult_idle_right

.globl _spr_ghost_difficult_run_left
.globl _spr_ghost_difficult_run_right

.globl _spr_ghost_difficult_die_left_0
.globl _spr_ghost_difficult_die_left_1
.globl _spr_ghost_difficult_die_left_2
.globl _spr_ghost_difficult_die_right_0
.globl _spr_ghost_difficult_die_right_1
.globl _spr_ghost_difficult_die_right_2


;;Num scores
.globl _spr_num_score_4 ;; Separation
.globl _spr_num_score_3 ;; 3
.globl _spr_num_score_2 ;; 2
.globl _spr_num_score_1 ;; 1
.globl _spr_num_score_0 ;; 0

;;Progress bar
.globl _spr_progress_arrow
.globl _spr_progress_line

;;Bullets
.globl _spr_p1_bullet_0
.globl _spr_p1_bullet_1
.globl _spr_p2_bullet_0
.globl _spr_p2_bullet_1
.globl _spr_ge_bullet_0
.globl _spr_ge_bullet_1
.globl _spr_gd_bullet_0
.globl _spr_gd_bullet_1
.globl _spr_we_bullet_0
.globl _spr_we_bullet_1
.globl _spr_wd_bullet_0
.globl _spr_wd_bullet_1

;;Bullet anim
.globl _spr_bullet_anim_0
.globl _spr_bullet_anim_1
.globl _spr_bullet_anim_2
.globl _spr_bullet_anim_3
.globl _spr_bullet_anim_4
.globl _spr_bullet_anim_5

;;Platforms
;;Platform_grass 
.globl _spr_platform_grass_0
.globl _spr_platform_grass_1

;;Platform_grass_rocks
.globl _spr_platform_grass_rocks_0
.globl _spr_platform_grass_rocks_1
.globl _spr_platform_grass_rocks_small_0
.globl _spr_platform_grass_rocks_small_1

;;Platform_rocks_grass
.globl _spr_platform_rocks_grass_0
.globl _spr_platform_rocks_grass_1
.globl _spr_platform_rocks_grass_small_0
.globl _spr_platform_rocks_grass_small_1

;;Platform_rocks
.globl _spr_platform_rocks_0
.globl _spr_platform_rocks_1
.globl _spr_platform_rocks_small_0
.globl _spr_platform_rocks_small_1

;;Intergame Frame
.globl _spr_intergame_frame_left_side
.globl _spr_intergame_frame_right_side
.globl _spr_intergame_frame_top_left
.globl _spr_intergame_frame_top_right
.globl _spr_intergame_frame_down_left
.globl _spr_intergame_frame_down_right